import java.io.File;
import java.io.IOException;
import java.util.Scanner;
import java.util.regex.Matcher;
import java.util.regex.Pattern;

/**
 * Created by thook on 10/7/15.
 */
public class HamletParser {

    private String hamletData;

    public HamletParser(){
        this.hamletData = loadFile();
    }

    private String loadFile(){
        ClassLoader classLoader = getClass().getClassLoader();
        File file = new File(classLoader.getResource("hamlet.txt").getFile());
        StringBuilder result = new StringBuilder("");

        try(Scanner scanner = new Scanner(file)){
            while(scanner.hasNextLine()){
                String line = scanner.nextLine();
                result.append(line).append("\n");
            }

            scanner.close();
        }catch(IOException e){
            e.printStackTrace();
        }

        return result.toString();
    }

    public String getHamletData(){
        return hamletData;
    }

    public int wordCounter(String stringToCount) {
        Pattern p = Pattern.compile(stringToCount);
        Matcher m = p.matcher(this.hamletData);
        int count = 0;
        while(m.find()){
            count++;
        }
        return count;

    }

    public void findAndReplace(String regex, String string) {

        Pattern replace = Pattern.compile(regex);

        Matcher regexMatcher = replace.matcher(this.hamletData);

        this.hamletData = regexMatcher.replaceAll(string);

    }
}
